VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "NotificationHints"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
' Autor: F. Schler (frank@activevb.de)
' Datum: 03/2023

Option Explicit

' ----==== Const ====----
Private Const IID_IIterable_IKeyValuePair_HSTRING_HSTRING As String = "{e9bdaaf0-cbf6-5c72-be90-29cbf3a1319b}"
Private Const IID_IIterator_IKeyValuePair_HSTRING_HSTRING As String = "{05eb86f1-7140-5517-b88d-cbaebe57e6b1}"
Private Const IID_IKeyValuePair_HSTRING_HSTRING As String = "{60310303-49c5-52e6-abc6-a9b36eccc716}"

' ----==== Enums ====----
Private Enum vtb_Interfaces

    ' IMap_HSTRING_HSTRING
    IMap_HSTRING_HSTRING_GetSize = 7
    
    ' IIterable_IKeyValuePair_HSTRING_HSTRING
    IIterable_IKeyValuePair_HSTRING_HSTRING_First = 6
    
    ' IIterator_IKeyValuePair_HSTRING_HSTRING
    IIterator_IKeyValuePair_HSTRING_HSTRING_GetCurrent = 6
    IIterator_IKeyValuePair_HSTRING_HSTRING_GetHasCurrent = 7
    IIterator_IKeyValuePair_HSTRING_HSTRING_MoveNext = 8

    ' IKeyValuePair_HSTRING_HSTRING
    IKeyValuePair_HSTRING_HSTRING_GetKey = 6
    IKeyValuePair_HSTRING_HSTRING_GetValue = 7
End Enum

' ----==== Variablen ====----
Private m_pIMap_HSTRING_HSTRING As Long

' ----==== Class ====----
Private Sub Class_Initialize()
    '
End Sub

Private Sub Class_Terminate()
    Call ReleaseIfc(m_pIMap_HSTRING_HSTRING)
End Sub

' ----==== Properties ====----
Public Property Get Ifc() As Long
    Ifc = m_pIMap_HSTRING_HSTRING
End Property

Public Property Let Ifc(ByVal pIMap_HSTRING_HSTRING As Long)
    Call ReleaseIfc(m_pIMap_HSTRING_HSTRING)
    m_pIMap_HSTRING_HSTRING = pIMap_HSTRING_HSTRING
End Property

' ----==== Functions ====----
' IMap_HSTRING_HSTRING
Public Function GetSize() As Long
    Dim Ret As Long
    If m_pIMap_HSTRING_HSTRING <> 0& Then
        Dim value As Long
        If Invoke(m_pIMap_HSTRING_HSTRING, _
                  IMap_HSTRING_HSTRING_GetSize, _
                  VarPtr(value)) = S_OK Then
            Ret = value
        End If
    End If
    GetSize = Ret
End Function

Friend Function GetKeyValuePairs() As KeyValuePair_HSTRING_HSTRING()
    Dim Ret() As KeyValuePair_HSTRING_HSTRING
    If m_pIMap_HSTRING_HSTRING <> 0& Then
        Dim count As Long
        count = Me.GetSize
        If count > 0& Then
            ReDim Ret(count - 1)
            Dim pIIterable_IKeyValuePair_HSTRING_HSTRING As Long
            If QueryIfc(m_pIMap_HSTRING_HSTRING, _
                        IID_IIterable_IKeyValuePair_HSTRING_HSTRING, _
                        pIIterable_IKeyValuePair_HSTRING_HSTRING) Then
                Dim pIIterator_IKeyValuePair_HSTRING_HSTRING As Long
                If Invoke(pIIterable_IKeyValuePair_HSTRING_HSTRING, _
                          IIterable_IKeyValuePair_HSTRING_HSTRING_First, _
                          VarPtr(pIIterator_IKeyValuePair_HSTRING_HSTRING)) = S_OK Then
                    Dim pIKeyValuePair_HSTRING_HSTRING As Long
                    If Invoke(pIIterator_IKeyValuePair_HSTRING_HSTRING, _
                              IIterator_IKeyValuePair_HSTRING_HSTRING_GetCurrent, _
                              VarPtr(pIKeyValuePair_HSTRING_HSTRING)) = S_OK Then
                        Dim value As Long
                        If Invoke(pIKeyValuePair_HSTRING_HSTRING, _
                                  IKeyValuePair_HSTRING_HSTRING_GetKey, _
                                  VarPtr(value)) = S_OK Then
                            Ret(0).key = GetWindowsString(value)
                        End If
                        If Invoke(pIKeyValuePair_HSTRING_HSTRING, _
                                  IKeyValuePair_HSTRING_HSTRING_GetValue, _
                                  VarPtr(value)) = S_OK Then
                            Ret(0).value = GetWindowsString(value)
                        End If
                        Call ReleaseIfc(pIKeyValuePair_HSTRING_HSTRING)
                    End If
                    Dim item As Long
                    For item = 1 To count
                        Dim moveNext As Boolean
                        If Invoke(pIIterator_IKeyValuePair_HSTRING_HSTRING, _
                                  IIterator_IKeyValuePair_HSTRING_HSTRING_MoveNext, _
                                  VarPtr(moveNext)) = S_OK Then
                            If moveNext Then
                                Dim pIKeyValuePair_HSTRING_HSTRING_Next As Long
                                If Invoke(pIIterator_IKeyValuePair_HSTRING_HSTRING, _
                                          IIterator_IKeyValuePair_HSTRING_HSTRING_GetCurrent, _
                                          VarPtr(pIKeyValuePair_HSTRING_HSTRING_Next)) = S_OK Then
                                    Dim value_Next As Long
                                    If Invoke(pIKeyValuePair_HSTRING_HSTRING_Next, _
                                              IKeyValuePair_HSTRING_HSTRING_GetKey, _
                                              VarPtr(value_Next)) = S_OK Then
                                        Ret(item).key = GetWindowsString(value_Next)
                                    End If
                                    If Invoke(pIKeyValuePair_HSTRING_HSTRING_Next, _
                                              IKeyValuePair_HSTRING_HSTRING_GetValue, _
                                              VarPtr(value_Next)) = S_OK Then
                                        Ret(item).value = GetWindowsString(value_Next)
                                    End If
                                    Call ReleaseIfc(pIKeyValuePair_HSTRING_HSTRING_Next)
                                End If
                            End If
                        End If
                    Next
                    Call ReleaseIfc(pIIterator_IKeyValuePair_HSTRING_HSTRING)
                End If
                Call ReleaseIfc(pIIterable_IKeyValuePair_HSTRING_HSTRING)
            End If
        End If
    End If
    GetKeyValuePairs = Ret
End Function

' ----==== Invoke Interface ====----
Private Function Invoke(ByVal pInterface As Long, _
                        ByVal vtb As vtb_Interfaces, _
                        ParamArray var()) As Variant
    If pInterface <> 0& Then
        Invoke = OleInvoke(pInterface, vtb, var)
    End If
End Function

